/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


%{

#define MEMCACHED_INTERNAL 1

#include <libmemcached/memcached.h>
#include <libmemcached/memcached_watchpoint.h>

  typedef struct st_byte {
    char * theString;
    int theLength;
  } BYTES;

enum ExceptionVal {
    BaseRuntimeError,
    MemcachedException

};

  %}

%include "exception.i"


%define %throwexception(EXCEPTION)
#if defined(SWIGJAVA)
%javaexception(EXCEPTION)
#else
%exception
#endif
%enddef

%define %nothrowexception
#if defined(SWIGJAVA)
%nojavaexception;
#else
%noexception;
#endif
%enddef

%inline %{

  typedef struct memcached_st Memcached;
  typedef struct memcached_stat_st MemcachedStat;
  typedef struct memcached_result_st MemcachedResult;
  typedef struct memcached_server_st MemcachedServer;
  %}

%nodefaultctor;
%rename memcached_st Memcached;
%rename memcached_stat_st MemcachedStat;
%rename memcached_result_st MemcachedResult;
%rename memcached_string_st MemcachedString;
%rename memcached_server_st MemcachedServer;

%rename memcached_allocated AllocatedVal;
%rename memcached_behavior BehaviorVal;
%rename memcached_callback CallbackVal;
%rename memcached_connection ConnectionVal;
%rename memcached_hash HashVal;
%rename memcached_return ReturnVal;
%rename memcached_server_distribution ServerDistributionVal;

%include "libmemcached/memcached_constants.h"
%include "libmemcached/memcached_watchpoint.h"

typedef long int32_t;
typedef unsigned long uint32_t;
typedef long long int64_t;
typedef unsigned long long uint64_t;
typedef unsigned short int uint16_t;
typedef unsigned char uint8_t;
typedef long time_t;

