/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

class memcached_result_st {

private:

  memcached_result_st();
  ~memcached_result_st();
  memcached_string_st value;
  char key[MEMCACHED_MAX_KEY];
  size_t key_length;
  memcached_st *root;
  memcached_allocated is_allocated;
  uint32_t flags;
  uint64_t cas;
  /* TODO: Add result callback function */

};

%extend memcached_result_st {

  memcached_string_st getValue() {
    return $self->value;
  }

  BYTES getKey() {
    BYTES theKey;
    theKey.theString=memcached_result_key_value($self);
    theKey.theLength=memcached_result_key_length($self);
    return theKey;
  }
};
