/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

class memcached_server_st {
  memcached_server_st();
  ~memcached_server_st();
  memcached_st *root;

  char write_buffer[MEMCACHED_MAX_BUFFER];
  size_t write_buffer_offset;
  char read_buffer[MEMCACHED_MAX_BUFFER];
  size_t read_data_length;
  size_t read_buffer_length;
  char *read_ptr;
  int fd;
  struct addrinfo *address_info;

public:

#if !defined(SWIG_RUBY_AUTORENAME)
  %rename(cachedErrno) cached_errno;
  %rename(cursorActive) cursor_active;
  %rename(sockAddrInited) sockaddr_inited;
  %rename(majorVersion) major_version;
  %rename(minorVersion) minor_version;
  %rename(microVersion) micro_version;
#endif

  char hostname[MEMCACHED_MAX_HOST_LENGTH];
  unsigned int port;
  %immutable;
  int cached_errno;
  unsigned int cursor_active;
  memcached_allocated sockaddr_inited;
  memcached_connection type;
  uint8_t major_version;
  uint8_t minor_version;
  uint8_t micro_version;
  uint16_t count;
  %mutable;
};
