/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


%module memcached

%include "arrays_java.i"
%include "various.i"
%include "enums.swg"

 /* swig/ in this context is in the local dir */
%include "swig/exceptions.i"
%include "swig/memcached_string.i"
%include "swig/arrays.i"
%include "swig/strings.i"
%include "swig/memcached_return.i"
%include "swig/byte_array.i"

%include "globals.i"

%rename(MemcacheImpl) memcached_st;
%rename(StatImpl)  memcached_stat_st;
%rename(ResultImpl) memcached_result_st;
%rename(ServerImpl) memcached_server_st;


%typemap(javainterfaces) memcached_st  "Memcache";
%typemap(javainterfaces) memcached_server_st "Server";
%typemap(javainterfaces) memcached_result_st "Result";
%typemap(javainterfaces) memcached_stat_st "Stat";

%include "memcache.i"

%include "memcached_server.i"
%include "memcached_stat.i"
%include "memcached_result.i"
