package org.tangent.memcached;

public interface Memcache {

	public abstract String getKey(String key, long value_length);

	public abstract String getByKey(String master_key, String key,
			long value_length);

	public abstract void getMultiple(String[] keys) throws MemcachedException;

	public abstract void setKey(String key, byte[] value, int expiration,
			long flags) throws MemcachedException;

	public abstract void setKey(String key, byte[] value, int expiration)
			throws MemcachedException;

	public abstract void setKey(String key, byte[] value)
			throws MemcachedException;

	public abstract void setByKey(String master_key, String key, byte[] value,
			int expiration, long flags) throws MemcachedException;

	public abstract void setByKey(String master_key, String key, byte[] value,
			int expiration) throws MemcachedException;

	public abstract void add(String key, byte[] value, int expiration,
			long flags) throws MemcachedException;

	public abstract void add(String key, byte[] value, int expiration)
			throws MemcachedException;

	public abstract void add(String key, byte[] value)
			throws MemcachedException;

	public abstract void replaceValue(String key, byte[] value, int expiration,
			long flags) throws MemcachedException;

	public abstract void replaceValue(String key, byte[] value, int expiration)
			throws MemcachedException;

	public abstract void replaceValue(String key, byte[] value)
			throws MemcachedException;

	public abstract void prependValue(String key, byte[] value, int expiration,
			long flags) throws MemcachedException;

	public abstract void prependValue(String key, byte[] value, int expiration)
			throws MemcachedException;

	public abstract void prependValue(String key, byte[] value)
			throws MemcachedException;

	public abstract void appendValue(String key, byte[] value, int expiration,
			long flags) throws MemcachedException;

	public abstract void appendValue(String key, byte[] value, int expiration)
			throws MemcachedException;

	public abstract void appendValue(String key, byte[] value)
			throws MemcachedException;

	public abstract void deleteKey(String key, int expiration)
			throws MemcachedException;

	public abstract void deleteKey(String key) throws MemcachedException;

	public abstract void deleteByKey(String master_key, String key,
			int expiration) throws MemcachedException;

	public abstract void deleteByKey(String master_key, String key)
			throws MemcachedException;

	public abstract void incrementKey(String key, long offset, long value)
			throws MemcachedException;

	public abstract void decrementKey(String key, long offset, long value)
			throws MemcachedException;

	public abstract void flush(int expiration) throws MemcachedException;

	public abstract void setBehavior(BehaviorVal flag, java.math.BigInteger data)
			throws MemcachedException;

	public abstract void addServer(String hostname, long port)
			throws MemcachedException;

	public abstract java.math.BigInteger getBehavior(BehaviorVal flag);

	public abstract void quit();

}