/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

%module memcached

%include "globals.i"

%{


//#define THROW_exception(excp, msg) { throw_exception(excp,msg); SWIG_fail; }
#define THROW_exception(excp, msg) { throw_exception(msg); SWIG_fail; }

    void throw_exception(const char * msg) {

	printf("Crap! Got an exception and we haven't written the code yet!\n");

    }

    %}

%typemap(out) memcached_return {
    $result = Py_None;
 }
%typemap(in) (char **keys, size_t *key_length, size_t number_of_keys) {
    if (PyList_Check($input)) {
	unsigned long i = 0;
	$3 = (size_t)PyList_Size($input);
	$2 = (size_t *) malloc(($3+1)*sizeof(size_t));
	$1 = (char **) malloc(($3+1));
	/* make a copy of each string */
	for (i = 0; i<$3; i++) {
	    PyObject *o = PyList_GetItem($input, i);
	    if (PyString_Check(o)) {
		$2[i] = PyString_Size(o);
		$1[i] = (char *)malloc($2[i]+1);
		strcpy($1[i], PyString_AsString(o));
	    }
	}
	$2[i] = 0;
	$1[i] = 0;
    } else {
	PyErr_SetString(PyExc_TypeError,"not a list");
	return NULL;
    }

 }

%typemap(in) (char * key, size_t key_length) {

    /* Check that we are getting a string */
    if (PyString_Check($input)) {
	// We are going to try not copying this string, since it's not going to
	// be modified and we're going to copy it in the main function
	$1=PyString_AsString($input);
	$2=PyString_Size($input);
    } else {
	PyErr_SetString(PyExc_TypeError,"Couldn't convert argument");
	return NULL;
    }
 }


%typemap(in) (char * master_key, size_t master_length) {

    /* Check that we are getting a string */
    if (PyString_Check($input)) {
	// We are going to try not copying this string, since it's not going to
	// be modified and we're going to copy it in the main function
	$1=PyString_AsString($input);
	$2=PyString_Size($input);
    } else {
	PyErr_SetString(PyExc_TypeError,"Couldn't convert argument");
	return NULL;
    }
 }

%typemap(in) (char * value, size_t value_length) {

    /* Check that we are getting a string */
    if (PyString_Check($input)) {
	// We are going to try not copying this string, since it's not going to
	// be modified and we're going to copy it in the main function
	$1=PyString_AsString($input);
	$2=PyString_Size($input);
    } else {
	PyErr_SetString(PyExc_TypeError,"Couldn't convert argument");
	return NULL;
    }
 }


%include "memcache.i"

%include "memcached_server.i"
%include "memcached_stat.i"
%include "memcached_result.i"
