/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


/* Not using directors with ruby - they don't seem to work and the 
   custom code is really clean anyway. */

%module memcached

%include "globals.i"

%typemap(out) memcached_return {
    $result = NULL;
 }
/*
%typemap(in) (char **keys, size_t *key_length, size_t number_of_keys) {


%typemap(in) (const char* anInputString, size_t len) {

  $1 = STR2CSTR($input);
  $2 = (size_t)RSTRING($input)->len;
 }
*/
%{

//#define THROW_exception(excp, msg) { throw_exception(excp,msg); SWIG_fail; }


#define THROW_exception(code,msg) do { raise_exception(code, msg); SWIG_fail; } while(0);
//#define THROW(code,msg,err) do { raise_exception(code, msg); SWIG_fail; } while(0);

#define getExceptionMethod(excptype,eparent) \
  SWIGINTERN VALUE \
get ## excptype () { \
  static int init ## excptype = 0 ; \
  static VALUE rb_e ## excptype ; \
  VALUE rb_eparent = get_exception (eparent); \
  if (! init ## excptype ) { \
    init ## excptype = 1; \
    rb_e ## excptype = rb_define_class(#excptype , rb_eparent); \
  } \
  return rb_e ## excptype ; \
}
VALUE get_exception(ExceptionVal excpcode);

getExceptionMethod(MemcachedException,BaseRuntimeError);

void raise_exception(ExceptionVal excpcode, const char * msg) {
  rb_raise(get_exception(excpcode),msg);
}

#define CASE_exception(excp) case excp : exception = get ## excp (); break;

VALUE get_exception(ExceptionVal excpcode) { 

 VALUE exception;

 switch (excpcode) {
    case BaseRuntimeError:
      exception = rb_eRuntimeError;
      break;
    CASE_exception(MemcachedException)
    default:
      exception = rb_eRuntimeError;
      break;
  }
  return exception;
}

 %}

%include "memcache.i"

%include "memcached_server.i"
%include "memcached_stat.i"
%include "memcached_result.i"
